{{ ---------------------------------------------------------------------------------------------------------

Hive-Computer-Projekt: YMODEM "Library"

xx-xx-2009      - 1. Version by Julian R.

Todo:
        - Upload via YMODEM
        - recieve files > 255kbyte
        - Batch file transfer? (maybe)

Big thanks to all ppl from the hive-project.de board. Especially DJLinux for the CRC routine.

 --------------------------------------------------------------------------------------------------------- }}
OBJ
  ios     : "ios"
  ser : "FullDuplexSerial256"     ' Full Duplex Serial Controller
  
CON
   '' Ymodem Protocol
  SOH           = 1               ' Packet Start 128byte
  STX           = 2               ' Packet Start 1024byte
  EOT           = 4               ' End of Transmission
  ACK           = 6               ' Positive Acknowledgement
  NAK           = 21              ' Negative Acknowledgement
  CAN           = 24              ' Cancel
'  PAD               = 26              ' Padding at the end of the file
'  RX_Buffer         = 20
  Cee           = 67              ' C to singalisize to be ready for/finished recieving data
  NUL           = 0               ' Filling Symbol for first package (0)

  ''crc
  P_CCITT      = $1021

   '' Serial Config
  serXmit       = 30              ' Serial Transmit
  serRecv       = 31              ' Serial Receive
  baud          = 9600            ' Baud Rate
  timeout       = 200             ' Timeout
    
PUB initserial
  ser.start(serRecv,serXmit,0,baud)                     ' init Serial Connection

PUB stopserial
  ser.stop
    
PUB initdownload | header                               ' Repeat this function until True
  ser.tx(Cee)                                           ' Send C to singalisize readiness
  header := ser.rxtime(timeout)
  if header == SOH                                      ' Check if remote site sent first packet
    return TRUE
  else
    return FALSE
  
PUB getheader | recv, retvalue
  recv := ser.rx
  Case recv
    SOH:
      retvalue := string("SOH")
    STX:
      retvalue := string("STX")
    EOT:
      retvalue := string("EOT")
    CAN:
      retvalue := string("CAN")
    Other:
      retvalue := string("UNK")

  return retvalue

PUB getpacknum | tmp, recv
  tmp := ser.rx                                         ' first Byte is NUL (files under 255kbyte)
  recv := ser.rx                                        ' Get Number
  return 255 - recv                                     ' Number counts down from 255

PUB getpack128 | buffer[128],i,test1
  repeat i from 0 to 127
    buffer[i] := ser.rx
  return buffer                                         'HIER LIEGT DER FEHLER (ODER IM HAUPTPROGRAMM)   

PUB getpack1k | buffer[1024],i
  repeat i from 0 to 1023
    buffer[i] := ser.rx
  return buffer

PUB getfilename(packet) | name,i,j,chr
  repeat i from 0 to 127
    chr := byte[packet[i]]
    if chr == NUL
      QUIT
  repeat j from 0 to i
    name += byte[packet[j]]
  return name

PUB getfilesize(packet,start) | size,i,j,chr
  repeat i from start to 127
    chr := byte[packet[i]]
    if chr == NUL
      QUIT
  repeat j from start to i
    size += byte[packet[j]]
  return size

PUB cancledownload
  ser.tx(CAN)
  ser.tx(CAN)
  ser.tx(CAN)
  ser.tx(CAN)

PUB sendack
  ser.tx(ACK)

PUB sendnak
  ser.tx(NAK)

PUB senddlstart
  ser.tx(ACK)
  ser.tx(Cee)
  
PUB senddlfinish
  ser.tx(ACK)
  ser.tx(Cee)
  ser.tx(ACK)
  
PUB calccrc(ptr) | i,j,count,crc,c
  crc := 0
  count := strsize(ptr)-1
  repeat i from 0 to count
    c := byte[ptr + i]  'byte[ptr][i]
    c := c << 8
    repeat j from 0 to 7
      if ( (crc ^ c) & $8000 )
        crc := (crc << 1) ^ P_CCITT
      else
        crc := crc << 1

      c := c << 1
      
  return crc